#!/bin/bash -e

CONTAINER_ALREADY_STARTED="/CONTAINER_ALREADY_STARTED_PLACEHOLDER"

if [ "$REDNER_ADMIN_PASSWORD" = "" ]; then
    REDNER_ADMIN_PASSWORD=admin
fi

/etc/init.d/postgresql start

if [ ! -e $CONTAINER_ALREADY_STARTED ]; then
    touch $CONTAINER_ALREADY_STARTED
    echo "-- First container startup --"

    su - postgres -c "createuser -s root"

    createdb redner

    /rednerd -c /config.ini migrate

    /rednerd -c /config.ini admin-password "$REDNER_ADMIN_PASSWORD"


    if [ "$REDNER_USER" != "" ]; then
        if [ "$REDNER_PASSWORD" = "" ]; then
            REDNER_PASSWORD="$REDNER_USER"
        fi
        echo "Creating user $REDNER_USER"

        /rednerd -c /config.ini serve --port 8080 &

        echo "Waiting for rednerd to be up..."
        while ! (curl http://localhost:8080 1>/dev/null 2>&1); do
            sleep 0.250
        done
        echo "rednerd is up"

        curl -X POST -c /tmp/cookies.txt -H Content-Type:application/json \
            --data-raw "{\"username\":\"admin\",\"password\":\"$REDNER_ADMIN_PASSWORD\",\"set-cookie\":true}" \
            http://127.0.0.1:8080/api/v1/auth/authenticate
        curl -X POST -b /tmp/cookies.txt -H Content-Type:application/json \
            http://127.0.0.1:8080/api/v1/user \
            --data-raw "{\"username\":\"$REDNER_USER\",\"is-admin\":false}"
        curl -X POST -b /tmp/cookies.txt -H Content-Type:application/json \
            http://127.0.0.1:8080/api/v1/user/$REDNER_USER/password \
            --data-raw "{\"password\":\"$REDNER_PASSWORD\"}"
        kill %1
    fi
else
    echo "-- Not first container startup --"
fi

if [ "$1" = "" ]; then
    /rednerd -c /config.ini serve
else
    /rednerd -c /config.ini "$@"
fi
