// Code generated by go-swagger; DO NOT EDIT.

package rendering

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRenderOneParams creates a new RenderOneParams object
// no default values defined in spec.
func NewRenderOneParams() RenderOneParams {

	return RenderOneParams{}
}

// RenderOneParams contains all the bound params for the render one operation
// typically these are obtained from a http.Request
//
// swagger:parameters render-one
type RenderOneParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*The mimetype expected after a rendering.

	  In: query
	*/
	Accept *string
	/*
	  Required: true
	  In: path
	*/
	Account string
	/*A JSON object containing the variables to inject into the template.

	  In: query
	*/
	Data *string
	/*
	  Required: true
	  In: path
	*/
	ID string
	/*A list of metadata in the form "Name: Value"

	  In: query
	*/
	Meta []string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewRenderOneParams() beforehand.
func (o *RenderOneParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qAccept, qhkAccept, _ := qs.GetOK("accept")
	if err := o.bindAccept(qAccept, qhkAccept, route.Formats); err != nil {
		res = append(res, err)
	}

	rAccount, rhkAccount, _ := route.Params.GetOK("account")
	if err := o.bindAccount(rAccount, rhkAccount, route.Formats); err != nil {
		res = append(res, err)
	}

	qData, qhkData, _ := qs.GetOK("data")
	if err := o.bindData(qData, qhkData, route.Formats); err != nil {
		res = append(res, err)
	}

	rID, rhkID, _ := route.Params.GetOK("id")
	if err := o.bindID(rID, rhkID, route.Formats); err != nil {
		res = append(res, err)
	}

	qMeta, qhkMeta, _ := qs.GetOK("meta")
	if err := o.bindMeta(qMeta, qhkMeta, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindAccept binds and validates parameter Accept from query.
func (o *RenderOneParams) bindAccept(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	o.Accept = &raw

	return nil
}

// bindAccount binds and validates parameter Account from path.
func (o *RenderOneParams) bindAccount(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.Account = raw

	return nil
}

// bindData binds and validates parameter Data from query.
func (o *RenderOneParams) bindData(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	o.Data = &raw

	return nil
}

// bindID binds and validates parameter ID from path.
func (o *RenderOneParams) bindID(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.ID = raw

	return nil
}

// bindMeta binds and validates array parameter Meta from query.
//
// Arrays are parsed according to CollectionFormat: "" (defaults to "csv" when empty).
func (o *RenderOneParams) bindMeta(rawData []string, hasKey bool, formats strfmt.Registry) error {

	var qvMeta string
	if len(rawData) > 0 {
		qvMeta = rawData[len(rawData)-1]
	}

	// CollectionFormat:
	metaIC := swag.SplitByFormat(qvMeta, "")
	if len(metaIC) == 0 {
		return nil
	}

	var metaIR []string
	for _, metaIV := range metaIC {
		metaI := metaIV

		metaIR = append(metaIR, metaI)
	}

	o.Meta = metaIR

	return nil
}
